package tech.nevets.tvpn.wg;

import tech.nevets.tvpn.Utils;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.concurrent.ThreadLocalRandom;

public class WGTesting {

    public static void main(String[] args) throws IOException, InterruptedException {
        List<String> configs = listConfigs();
        //String currentTunnel = getCurrentTunnel();
        //System.out.println(currentTunnel);
        //pullTunnelConfig(currentTunnel);
        //WireGuardHandler.stopTunnel(currentTunnel);
        Random r = ThreadLocalRandom.current();
        int index = r.nextInt(configs.size());
        System.out.println("Index: " + index);
        System.out.println("Random Tunnel: " + configs.get(index).substring(0, configs.get(index).length() - 11));
        //WireGuardHandler.startTunnel(configs.get(index).substring(0, configs.get(index).length() - 11));
    }

    public static String getCurrentTunnel() throws IOException {
        String[] rSplit = getWGShowLines();
        for (String s : rSplit) {
            if (s.toLowerCase().contains("interface")) {
                return s.split(":")[1].trim();
            }
        }
        return "";
    }

    public static List<String> getCurrentTunnels() throws IOException {
        String[] rSplit = getWGShowLines();
        List<String> tunnels = new ArrayList<>();
        for (String s : rSplit) {
            if (s.toLowerCase().contains("interface")) {
                tunnels.add(s.split(":")[1].trim());
            }
        }
        return tunnels;
    }

    public static String[] getWGShowLines() throws IOException {
        ProcessBuilder pb = new ProcessBuilder();
        pb.command("cmd", "/C", "wg.exe", "show");
        Process p = pb.start();
        String result = new String(p.getInputStream().readAllBytes());
        return result.split("\n");
    }

    public static void pullTunnelConfig(String tunnelName) throws IOException {
        ProcessBuilder pb = new ProcessBuilder();
        pb.redirectOutput(new File(Utils.APP_DIR + "/" + tunnelName + ".conf"));
        pb.redirectError(ProcessBuilder.Redirect.INHERIT);
        pb.command("cmd", "/C", "wg.exe", "showconf", tunnelName);
        pb.start();
    }

    public static List<String> listConfigs() throws IOException {
        List<Path> filePaths = new ArrayList<>();
        Path path = Path.of(Utils.WG_CONF_DIR);
        Files.walk(path)
                .filter(Files::isRegularFile)
                .forEach(filePaths::add);
        List<String> fileNames = new ArrayList<>();
        for(Path p : filePaths) {
            String fullPath = p.toString();
            fileNames.add(fullPath.substring(fullPath.lastIndexOf("\\") + 1));
        }
        return fileNames;
    }

}
